// AddChemicalDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ChemMonitor.h"
#include "AddChemicalDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

char const* gChemicalDescriptions[] =
{
	"<NONE>",
	"Pain",
	"Need for Pleasure",
	"Hunger",
	"Coldness",
	"Hotness",
	"Tiredness",
	"Sleepiness",
	"Loneliness",
	"Crowded",
	"Fear",
	"Boredom",
	"Anger",
	"Sex Drive",
	"not_allocated2",
	"not_allocated3",
	"not_allocated4",
	"Pain Increase",
	"Need for Pleasure Increase",
	"Hunger Increase",
	"Coldness Increase",
	"Hotness Increase",
	"Tiredness Increase",
	"Sleepiness Increase",
	"Loneliness Increase",
	"Crowded Increase",
	"Fear Increase",
	"Boredom Increase",
	"Anger Increase",
	"Sex Drive Increase",
	"not_allocated2++",
	"not_allocated3++",
	"not_allocated4++",
	"Pain Decrease",
	"Need for Pleasure Decrease",
	"Hunger Decrease",
	"Coldness Decrease",
	"Hotness Decrease",
	"Tiredness Decrease",
	"Sleepiness Decrease",
	"Loneliness Decrease",
	"Crowded Decrease",
	"Fear Decrease",
	"Boredom Decrease",
	"Anger Decrease",
	"Sex Drive Decrease",
	"not_allocated2--",
	"not_allocated3--",
	"not_allocated4--",
	"Reward",
	"Punishment",
	"Reinforcement",
	"ConASH",
	"DecASH1",
	"Reward Echo",
	"Punish Echo",
	"Ageing",
	"Starch",
	"Glucose",
	"Glycogen",
	"Waste Water",
	"Hexokinase",
	"Carbon Dioxide",
	"Oestrogen",
	"Testosterone",
	"Gonadotrophin",
	"Progesterone",
	"Glycotoxin",
	"Alcohol",
	"Adrenaline",
	"DecASH2",
	"Vitamin E",
	"Vitamin C",
	"73",
	"74",
	"75",
	"76",
	"77",
	"78",
	"79",
	"80",
	"81",
	"82",
	"83",
	"84",
	"85",
	"86",
	"87",
	"88",
	"89",
	"90",
	"91",
	"92",
	"93",
	"94",
	"95",
	"96",
	"97",
	"98",
	"99",
	"Energy",
	"Adrenaline",
	"Pain Killer",
	"Cough Medicine",
	"Sleeping Pill",
	"Wake-up Pill",
	"Anti-oxidant",
	"107",
	"108",
	"109",
	"110",
	"111",
	"112",
	"113",
	"114",
	"115",
	"116",
	"117",
	"118",
	"119",
	"120",
	"121",
	"122",
	"123",
	"124",
	"125",
	"126",
	"127",
	"128",
	"129",
	"130",
	"131",
	"132",
	"133",
	"134",
	"135",
	"136",
	"137",
	"138",
	"139",
	"140",
	"141",
	"142",
	"143",
	"144",
	"145",
	"146",
	"147",
	"148",
	"149",
	"150",
	"151",
	"152",
	"153",
	"154",
	"155",
	"156",
	"157",
	"158",
	"159",
	"160",
	"161",
	"162",
	"163",
	"164",
	"165",
	"166",
	"167",
	"168",
	"169",
	"170",
	"171",
	"172",
	"173",
	"174",
	"175",
	"176",
	"177",
	"178",
	"179",
	"180",
	"181",
	"182",
	"183",
	"184",
	"185",
	"186",
	"187",
	"188",
	"189",
	"190",
	"191",
	"192",
	"193",
	"194",
	"195",
	"196",
	"197",
	"198",
	"199",
	"200",
	"201",
	"202",
	"203",
	"204",
	"205",
	"206",
	"207",
	"208",
	"209",
	"210",
	"211",
	"212",
	"213",
	"214",
	"215",
	"216",
	"217",
	"218",
	"219",
	"220",
	"221",
	"222",
	"223",
	"224",
	"225",
	"226",
	"227",
	"228",
	"229",
	"230",
	"Geddonase",
	"Histamine A",
	"Histamine B",
	"Sleep toxin",
	"Fever toxin",
	"unknown toxin",
	"unknown toxin",
	"unknown toxin",
	"unknown toxin",
	"Antibody 0",
	"Antibody 1",
	"Antibody 2",
	"Antibody 3",
	"Antibody 4",
	"Antibody 5",
	"Antibody 6",
	"Antibody 7",
	"Antigen 0",
	"Antigen 1",
	"Antigen 2",
	"Antigen 3",
	"Antigen 4",
	"Antigen 5",
	"Antigen 6",
	"Antigen 7"
};
const int gNumberOfDescriptions = sizeof(gChemicalDescriptions) / sizeof(gChemicalDescriptions[0]);

/////////////////////////////////////////////////////////////////////////////
// CAddChemicalDlg dialog


CAddChemicalDlg::CAddChemicalDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAddChemicalDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAddChemicalDlg)
	fDescription = _T(gChemicalDescriptions[0]);
	fChemicalNumber = 0;
	//}}AFX_DATA_INIT
}


void CAddChemicalDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAddChemicalDlg)
	DDX_Control(pDX, IDC_CHEM_EDIT, fChemEditControl);
	DDX_Control(pDX, IDC_ADD_SPIN, fAddSpin);
	DDX_Text(pDX, IDC_DESC_EDIT, fDescription);
	DDX_Text(pDX, IDC_CHEM_EDIT, fChemicalNumber);
	DDV_MinMaxUInt(pDX, fChemicalNumber, 0, 255);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAddChemicalDlg, CDialog)
	//{{AFX_MSG_MAP(CAddChemicalDlg)
	ON_EN_CHANGE(IDC_CHEM_EDIT, OnChangeChemEdit)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAddChemicalDlg message handlers

void CAddChemicalDlg::OnChangeChemEdit() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function to send the EM_SETEVENTMASK message to the control
	// with the ENM_CHANGE flag ORed into the lParam mask.
	
	// TODO: Add your control notification handler code here
	if(IsWindow(*this) && IsWindow(fChemEditControl))
	{
		UpdateData(TRUE);

		if(fChemicalNumber >= gNumberOfDescriptions)
		{
			fDescription.Format("%d", fChemicalNumber);
		}
		else
		{
			fDescription = gChemicalDescriptions[fChemicalNumber];
		}

		UpdateData(FALSE);
	}
}

BOOL CAddChemicalDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	fAddSpin.SetRange(0, 255);
	fDescription = gChemicalDescriptions[0];
		
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
