// ChemMonitorDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ChemMonitor.h"
#include "ChemMonitorDlg.h"
#include "AddChemicalDlg.h"
#include <sstream>
#include <iomanip>
#include <cassert>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CChemMonitorDlg dialog

CChemMonitorDlg::CChemMonitorDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CChemMonitorDlg::IDD, pParent),
	fSession(0),
	fTimerHandle(0)
{
	//{{AFX_DATA_INIT(CChemMonitorDlg)
	fCAOSText = _T("");
	fResultText = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

CChemMonitorDlg::~CChemMonitorDlg()
{
	delete fSession;
}

void CChemMonitorDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CChemMonitorDlg)
	DDX_Control(pDX, IDOK, fCloseButton);
	DDX_Control(pDX, IDC_RESULT_EDIT, fResultEdit);
	DDX_Control(pDX, IDC_CHEM_LIST, fChemList);
	DDX_Control(pDX, IDC_CAOS_EDIT, fCAOSEdit);
	DDX_Control(pDX, IDC_REMOVE_BUTTON, fRemoveButton);
	DDX_Control(pDX, IDC_EXECUTE_BUTTON, fExecuteButton);
	DDX_Control(pDX, IDC_DISCONNECT_BUTTON, fDisconnectButton);
	DDX_Control(pDX, IDC_CONNECT_BUTTON, fConnectButton);
	DDX_Control(pDX, IDC_ADD_BUTTON, fAddButton);
	DDX_Text(pDX, IDC_CAOS_EDIT, fCAOSText);
	DDX_Text(pDX, IDC_RESULT_EDIT, fResultText);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CChemMonitorDlg, CDialog)
	//{{AFX_MSG_MAP(CChemMonitorDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_CONNECT_BUTTON, OnConnectButton)
	ON_BN_CLICKED(IDC_DISCONNECT_BUTTON, OnDisconnectButton)
	ON_BN_CLICKED(IDC_ADD_BUTTON, OnAddButton)
	ON_BN_CLICKED(IDC_REMOVE_BUTTON, OnRemoveButton)
	ON_BN_CLICKED(IDC_EXECUTE_BUTTON, OnExecuteButton)
	ON_LBN_SELCHANGE(IDC_CHEM_LIST, OnSelchangeChemList)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CChemMonitorDlg message handlers

BOOL CChemMonitorDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	ResetButtons();
	fCAOSText = "inst,stim writ norn 0 255 0 0 1 255 2 255 3 255 4 255,endm";
	UpdateData(FALSE);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CChemMonitorDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CChemMonitorDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CChemMonitorDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CChemMonitorDlg::ResetButtons()
{ 
	if(fSession != 0) // we are connected
	{
		fConnectButton.EnableWindow(false);
		fDisconnectButton.EnableWindow(true);
		fCloseButton.EnableWindow(false);
		fResultEdit.EnableWindow(true);
		fChemList.EnableWindow(true);
		fCAOSEdit.EnableWindow(true);
		fExecuteButton.EnableWindow(true);
		fAddButton.EnableWindow(true);
	}
	else // we are disconnected
	{
		fConnectButton.EnableWindow(true);
		fDisconnectButton.EnableWindow(false);
		fCloseButton.EnableWindow(true);
		fResultEdit.EnableWindow(false);
		fChemList.EnableWindow(false);
		fCAOSEdit.EnableWindow(false);
		fExecuteButton.EnableWindow(false);
		fAddButton.EnableWindow(false);
	}

	// Disable remove button if there is no selected item
	fRemoveButton.EnableWindow(fChemList.GetCurSel() != LB_ERR);
}

void CChemMonitorDlg::OnConnectButton() 
{
	// TODO: Add your control notification handler code here
	assert(fSession == 0);

	try
	{
		fSession = new Creatures::Session();
		// As a test, get the creatures name and display it
		std::string name = fSession->executeMacro("inst,dde: getb cnam,endm");
		std::string title = "ChemMonitor - " + name; 
		SetWindowText(title.c_str());
		ResetButtons();
		StartTimer();	
	}
	catch(Creatures::DDEException&)
	{ 
		MessageBox("An error occurred trying to connect to Creatures.\nPlease ensure that Creatures is running and a norn is selected.",
			"Unable to connect");
	}
}

void CChemMonitorDlg::OnDisconnectButton() 
{
	// TODO: Add your control notification handler code here
	StopTimer();
	delete fSession;
	fSession = 0;
	ResetButtons();
	SetWindowText("ChemMonitor");
}

void CChemMonitorDlg::StartTimer()
{
	if(fTimerHandle != 0)
		StopTimer();

	fTimerHandle = SetTimer(1, 500, 0);
	if(fTimerHandle == 0)
	{
		MessageBox("Unable to start timer");
	}

}

void CChemMonitorDlg::StopTimer()
{
	if(fTimerHandle != 0)
	{
		if(!KillTimer(1))
		{
			MessageBox("Unable to stop timer");
		}
		fTimerHandle = 0;
	}
}

void CChemMonitorDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	UpdateData(TRUE);

	try
	{
		StopTimer();

		if(!fMacroToExecute.empty())
		{
			fResultText = fSession->executeMacro(fMacroToExecute.c_str());
			fMacroToExecute = "";
		}

		int count = fChemList.GetCount();
		if(count > 0)
		{
			int currentSelection = fChemList.GetCurSel();

			std::ostringstream macro;
			macro << "inst,";
			for(int i = 0; i < count; ++i)
			{
				macro << "dde: putv chem "
					  << fChemList.GetItemData(i);
				if(i != count - 1)
				{
					macro << " ";
				}
			}

			macro << ",endm" << std::ends;

			std::string result = fSession->executeMacro(macro.str().c_str());

			int position = 0;
			for(int j = 0; j < count; ++j)
			{
				int value = atoi(result.substr(position).c_str());
				int chemical = fChemList.GetItemData(j);
				std::ostringstream text;
				text << std::setw(3)
					<< std::setfill('0')
					<< value
					<< " - "
					<< chemical
					<< " - "
					<< gChemicalDescriptions[chemical]
					<< std::ends;

				position = result.find("|", position) + 1;
				fChemList.InsertString(j, text.str().c_str());
				fChemList.SetItemData(j, chemical);
				fChemList.DeleteString(j + 1); 
			}
			if(currentSelection != LB_ERR)
			{
				fChemList.SetCurSel(currentSelection);
			}
		}

		StartTimer();
	}
	catch(Creatures::DDEException&)
	{
		MessageBox("DDE Exception");
		OnDisconnectButton();
	}
	
	CDialog::OnTimer(nIDEvent);

	UpdateData(FALSE);
}


void CChemMonitorDlg::OnExecuteButton() 
{
	// TODO: Add your control notification handler code here
	StopTimer();
	UpdateData(TRUE);
	fMacroToExecute = fCAOSText;
	StartTimer();	
}


void CChemMonitorDlg::OnAddButton() 
{
	// TODO: Add your control notification handler code here
	if(fSession != 0) StopTimer();
	CAddChemicalDlg dialog;
	if(dialog.DoModal() == IDOK)
	{
		std::ostringstream text;
		text << std::setw(3)
			<< std::setfill('0')
			<< 0
			<< " - "
			<< dialog.fChemicalNumber
			<< " - "
			<< gChemicalDescriptions[dialog.fChemicalNumber]
			<< std::ends;

		int index = fChemList.AddString(text.str().c_str());
		fChemList.SetItemData(index, dialog.fChemicalNumber);
	}
	if(fSession != 0)  StartTimer();
}

void CChemMonitorDlg::OnSelchangeChemList() 
{
	// TODO: Add your control notification handler code here
	fRemoveButton.EnableWindow(fChemList.GetCurSel() != LB_ERR);	
}

void CChemMonitorDlg::OnRemoveButton() 
{
	// TODO: Add your control notification handler code here
	if(fSession != 0) StopTimer(); 
	fChemList.DeleteString(fChemList.GetCurSel());	
	ResetButtons();
	if(fSession != 0)  StartTimer();
}
